Index: /palm/trunk/SOURCE/diffusion_e.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_e.f90	(revision 1014)
+++ /palm/trunk/SOURCE/diffusion_e.f90	(revision 1015)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! -----------------
-!
+! accelerator version (*_acc) added,
+! adjustment of mixing length to the Prandtl mixing length at first grid point
+! above ground removed
 !
 ! Former revisions:
@@ -56,5 +58,5 @@
 
     PRIVATE
-    PUBLIC diffusion_e
+    PUBLIC diffusion_e, diffusion_e_acc
     
 
@@ -64,4 +66,8 @@
     END INTERFACE diffusion_e
  
+    INTERFACE diffusion_e_acc
+       MODULE PROCEDURE diffusion_e_acc
+    END INTERFACE diffusion_e_acc
+
  CONTAINS
 
@@ -81,5 +87,5 @@
 
        INTEGER ::  i, j, k
-       REAL    ::  dvar_dz, l_stable, phi_m, var_reference
+       REAL    ::  dvar_dz, l_stable, var_reference
 
 #if defined( __nopointer )
@@ -98,15 +104,4 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-!
-!--             First, calculate phi-function for eventually adjusting the &
-!--             mixing length to the prandtl mixing length
-                IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-                   IF ( rif(j,i) >= 0.0 )  THEN
-                      phi_m = 1.0 + 5.0 * rif(j,i)
-                   ELSE
-                      phi_m = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif(j,i) ) )
-                   ENDIF
-                ENDIF
-
                 DO  k = nzb_s_inner(j,i)+1, nzt
 !
@@ -133,12 +128,4 @@
                       ll(k,j) = l_grid(k)
                    ENDIF
-                   IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-                      l(k,j)  = MIN( l(k,j),  kappa *                          &
-                                              ( zu(k) - zw(nzb_s_inner(j,i)) ) &
-                                              / phi_m )
-                      ll(k,j) = MIN( ll(k,j), kappa *                          &
-                                              ( zu(k) - zw(nzb_s_inner(j,i)) ) &
-                                              / phi_m )
-                   ENDIF
 
                 ENDDO
@@ -188,15 +175,4 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-!
-!--             First, calculate phi-function for eventually adjusting the &
-!--             mixing length to the prandtl mixing length
-                IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-                   IF ( rif(j,i) >= 0.0 )  THEN
-                      phi_m = 1.0 + 5.0 * rif(j,i)
-                   ELSE
-                      phi_m = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif(j,i) ) )
-                   ENDIF
-                ENDIF
-
                 DO  k = nzb_s_inner(j,i)+1, nzt
 !
@@ -223,12 +199,4 @@
                       ll(k,j) = l_grid(k)
                    ENDIF
-                   IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-                      l(k,j)  = MIN( l(k,j),  kappa *                          &
-                                              ( zu(k) - zw(nzb_s_inner(j,i)) ) &
-                                              / phi_m )
-                      ll(k,j) = MIN( ll(k,j), kappa *                          &
-                                              ( zu(k) - zw(nzb_s_inner(j,i)) ) &
-                                              / phi_m )
-                   ENDIF
 
                 ENDDO
@@ -290,7 +258,7 @@
 
 !------------------------------------------------------------------------------!
-! Call for grid point i,j
-!------------------------------------------------------------------------------!
-    SUBROUTINE diffusion_e_ij( i, j, var, var_reference )
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_e_acc( var, var_reference )
 
        USE arrays_3d
@@ -303,5 +271,189 @@
 
        INTEGER ::  i, j, k
-       REAL    ::  dvar_dz, l_stable, phi_m, var_reference
+       REAL    ::  dissipation, dvar_dz, l, ll, l_stable, var_reference
+
+#if defined( __nopointer )
+       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var
+#else
+       REAL, DIMENSION(:,:,:), POINTER ::  var
+#endif
+
+
+!
+!--    This if clause must be outside the k-loop because otherwise
+!--    runtime errors occur with -C hopt on NEC
+       IF ( use_reference )  THEN
+          STOP '+++ use_reference in diffusion_e not implemented'
+!          DO  i = nxl, nxr
+!             DO  j = nys, nyn
+!                DO  k = nzb_s_inner(j,i)+1, nzt
+!
+!--                Calculate the mixing length (for dissipation)
+!                   dvar_dz = atmos_ocean_sign * &
+!                             ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
+!                   IF ( dvar_dz > 0.0 ) THEN
+!                      l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+!                                 SQRT( g / var_reference * dvar_dz ) + 1E-5
+!                   ELSE
+!                      l_stable = l_grid(k)
+!                   ENDIF
+!
+!--                Adjustment of the mixing length
+!                   IF ( wall_adjustment )  THEN
+!                      l(k,j)  = MIN( wall_adjustment_factor *          &
+!                                     ( zu(k) - zw(nzb_s_inner(j,i)) ), &
+!                                     l_grid(k), l_stable )
+!                      ll(k,j) = MIN( wall_adjustment_factor *          &
+!                                     ( zu(k) - zw(nzb_s_inner(j,i)) ), &
+!                                     l_grid(k) )
+!                   ELSE
+!                      l(k,j)  = MIN( l_grid(k), l_stable )
+!                      ll(k,j) = l_grid(k)
+!                   ENDIF
+!
+!                ENDDO
+!             ENDDO
+!
+!
+!--          Calculate the tendency terms
+!             DO  j = nys, nyn
+!                DO  k = nzb_s_inner(j,i)+1, nzt
+!
+!                    dissipation(k,j) = ( 0.19 + 0.74 * l(k,j) / ll(k,j) ) * &
+!                                       e(k,j,i) * SQRT( e(k,j,i) ) / l(k,j)
+!
+!                    tend(k,j,i) = tend(k,j,i)                                  &
+!                                        + (                                    &
+!                          ( km(k,j,i)+km(k,j,i+1) ) * ( e(k,j,i+1)-e(k,j,i) )  &
+!                        - ( km(k,j,i)+km(k,j,i-1) ) * ( e(k,j,i)-e(k,j,i-1) )  &
+!                                          ) * ddx2                             &
+!                                        + (                                    &
+!                          ( km(k,j,i)+km(k,j+1,i) ) * ( e(k,j+1,i)-e(k,j,i) )  &
+!                        - ( km(k,j,i)+km(k,j-1,i) ) * ( e(k,j,i)-e(k,j-1,i) )  &
+!                                          ) * ddy2                             &
+!                                        + (                                    &
+!               ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+!             - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
+!                                          ) * ddzw(k)                          &
+!                             - dissipation(k,j)
+!
+!                ENDDO
+!             ENDDO
+!
+!
+!--          Store dissipation if needed for calculating the sgs particle
+!--          velocities
+!             IF ( use_sgs_for_particles  .OR.  wang_kernel )  THEN
+!                DO  j = nys, nyn
+!                   DO  k = nzb_s_inner(j,i)+1, nzt
+!                      diss(k,j,i) = dissipation(k,j)
+!                   ENDDO
+!                ENDDO
+!             ENDIF
+!
+!          ENDDO
+!
+       ELSE
+
+          !$acc kernels present( ddzu, ddzw, dd2zu, diss, e, km, l_grid ) &
+          !$acc         present( nzb_s_inner, rif, tend, var, zu, zw )
+          !$acc loop
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                !$acc loop vector( 32 )
+                DO  k = 1, nzt
+
+                   IF ( k > nzb_s_inner(j,i) )  THEN
+!
+!--                   Calculate the mixing length (for dissipation)
+                      dvar_dz = atmos_ocean_sign * &
+                                ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
+                      IF ( dvar_dz > 0.0 ) THEN
+                         l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                                           SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
+                      ELSE
+                         l_stable = l_grid(k)
+                      ENDIF
+!
+!--                   Adjustment of the mixing length
+                      IF ( wall_adjustment )  THEN
+                         l  = MIN( wall_adjustment_factor *          &
+                                   ( zu(k) - zw(nzb_s_inner(j,i)) ), &
+                                     l_grid(k), l_stable )
+                         ll = MIN( wall_adjustment_factor *          &
+                                   ( zu(k) - zw(nzb_s_inner(j,i)) ), &
+                                   l_grid(k) )
+                      ELSE
+                         l  = MIN( l_grid(k), l_stable )
+                         ll = l_grid(k)
+                      ENDIF
+!
+!--                   Calculate the tendency terms
+                      dissipation = ( 0.19 + 0.74 * l / ll ) * &
+                                    e(k,j,i) * SQRT( e(k,j,i) ) / l
+
+                      tend(k,j,i) = tend(k,j,i)                                &
+                                        + (                                    &
+                          ( km(k,j,i)+km(k,j,i+1) ) * ( e(k,j,i+1)-e(k,j,i) )  &
+                        - ( km(k,j,i)+km(k,j,i-1) ) * ( e(k,j,i)-e(k,j,i-1) )  &
+                                          ) * ddx2                             &
+                                        + (                                    &
+                          ( km(k,j,i)+km(k,j+1,i) ) * ( e(k,j+1,i)-e(k,j,i) )  &
+                        - ( km(k,j,i)+km(k,j-1,i) ) * ( e(k,j,i)-e(k,j-1,i) )  &
+                                          ) * ddy2                             &
+                                        + (                                    &
+               ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+             - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
+                                          ) * ddzw(k)                          &
+                             - dissipation
+
+!
+!--                   Store dissipation if needed for calculating the sgs
+!--                   particle  velocities
+                      IF ( use_sgs_for_particles  .OR.  wang_kernel )  THEN
+                         diss(k,j,i) = dissipation
+                      ENDIF
+
+                   ENDIF
+
+                ENDDO
+             ENDDO
+          ENDDO
+          !$acc end kernels
+
+       ENDIF
+
+!
+!--    Boundary condition for dissipation
+       IF ( use_sgs_for_particles  .OR.  wang_kernel )  THEN
+          !$acc kernels present( diss, nzb_s_inner )
+          !$acc loop
+          DO  i = nxl, nxr
+             !$acc loop vector( 32 )
+             DO  j = nys, nyn
+                diss(nzb_s_inner(j,i),j,i) = diss(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
+          ENDDO
+          !$acc end kernels
+       ENDIF
+
+    END SUBROUTINE diffusion_e_acc
+
+
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_e_ij( i, j, var, var_reference )
+
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
+       USE particle_attributes
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  dvar_dz, l_stable, var_reference
 
 #if defined( __nopointer )
@@ -312,15 +464,4 @@
        REAL, DIMENSION(nzb+1:nzt) ::  dissipation, l, ll
 
-
-!
-!--    First, calculate phi-function for eventually adjusting the mixing length
-!--    to the prandtl mixing length
-       IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-          IF ( rif(j,i) >= 0.0 )  THEN
-             phi_m = 1.0 + 5.0 * rif(j,i)
-          ELSE
-             phi_m = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif(j,i) ) )
-          ENDIF
-       ENDIF
 
 !
@@ -352,11 +493,4 @@
              ll(k) = l_grid(k)
           ENDIF
-          IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-             l(k)  = MIN( l(k),  kappa * &
-                                 ( zu(k) - zw(nzb_s_inner(j,i)) ) / phi_m )
-             ll(k) = MIN( ll(k), kappa * &
-                                 ( zu(k) - zw(nzb_s_inner(j,i)) ) / phi_m )
-          ENDIF
-
 !
 !--       Calculate the tendency term
Index: /palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_s.f90	(revision 1014)
+++ /palm/trunk/SOURCE/diffusion_s.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! ------------------
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -48,5 +48,5 @@
 
     PRIVATE
-    PUBLIC diffusion_s
+    PUBLIC diffusion_s, diffusion_s_acc
 
     INTERFACE diffusion_s
@@ -54,4 +54,8 @@
        MODULE PROCEDURE diffusion_s_ij
     END INTERFACE diffusion_s
+
+    INTERFACE diffusion_s_acc
+       MODULE PROCEDURE diffusion_s_acc
+    END INTERFACE diffusion_s_acc
 
  CONTAINS
@@ -173,7 +177,7 @@
 
 !------------------------------------------------------------------------------!
-! Call for grid point i,j
-!------------------------------------------------------------------------------!
-    SUBROUTINE diffusion_s_ij( i, j, s, s_flux_b, s_flux_t, wall_s_flux )
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_s_acc( s, s_flux_b, s_flux_t, wall_s_flux )
 
        USE arrays_3d
@@ -194,4 +198,125 @@
 #endif
 
+       !$acc kernels present( ddzu, ddzw, fwxm, fwxp, fwym, fwyp, kh )        &
+       !$acc         present( nzb_diff_s_inner, nzb_s_inner, nzb_s_outer, s ) &
+       !$acc         present( s_flux_b, s_flux_t, tend, wall_s_flux )         &
+       !$acc         present( wall_w_x, wall_w_y )
+       !$acc loop
+       DO  i = nxl, nxr
+          DO  j = nys,nyn
+!
+!--          Compute horizontal diffusion
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt
+                IF ( k > nzb_s_outer(j,i) )  THEN
+
+                   tend(k,j,i) = tend(k,j,i)                                  &
+                                          + 0.5 * (                           &
+                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) ) &
+                      - ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) ) &
+                                                  ) * ddx2                    &
+                                          + 0.5 * (                           &
+                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) ) &
+                      - ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) ) &
+                                                  ) * ddy2
+                ENDIF
+             ENDDO
+
+!
+!--          Apply prescribed horizontal wall heatflux where necessary
+             !$acc loop vector(32)
+             DO  k = 1, nzt
+                IF ( k > nzb_s_inner(j,i)  .AND.  k <= nzb_s_outer(j,i)  .AND. &
+                     ( wall_w_x(j,i) /= 0.0  .OR.  wall_w_y(j,i) /= 0.0 ) )    &
+                THEN
+                   tend(k,j,i) = tend(k,j,i)                                  &
+                                                + ( fwxp(j,i) * 0.5 *         &
+                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) ) &
+                        + ( 1.0 - fwxp(j,i) ) * wall_s_flux(1)                &
+                                                   -fwxm(j,i) * 0.5 *         &
+                        ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) ) &
+                        + ( 1.0 - fwxm(j,i) ) * wall_s_flux(2)                &
+                                                  ) * ddx2                    &
+                                                + ( fwyp(j,i) * 0.5 *         &
+                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) ) &
+                        + ( 1.0 - fwyp(j,i) ) * wall_s_flux(3)                &
+                                                   -fwym(j,i) * 0.5 *         &
+                        ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) ) &
+                        + ( 1.0 - fwym(j,i) ) * wall_s_flux(4)                &
+                                                  ) * ddy2
+                ENDIF
+             ENDDO
+
+!
+!--          Compute vertical diffusion. In case that surface fluxes have been
+!--          prescribed or computed at bottom and/or top, index k starts/ends at
+!--          nzb+2 or nzt-1, respectively.
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt_diff
+                IF ( k >= nzb_diff_s_inner(j,i) )  THEN
+                   tend(k,j,i) = tend(k,j,i)                                  &
+                                       + 0.5 * (                              &
+            ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1) &
+          - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)   &
+                                               ) * ddzw(k)
+                ENDIF
+             ENDDO
+
+!
+!--          Vertical diffusion at the first computational gridpoint along
+!--          z-direction
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt
+                IF ( use_surface_fluxes  .AND.  k == nzb_s_inner(j,i)+1 )  THEN
+                   tend(k,j,i) = tend(k,j,i)                                  &
+                                          + ( 0.5 * ( kh(k,j,i)+kh(k+1,j,i) ) &
+                                                  * ( s(k+1,j,i)-s(k,j,i) )   &
+                                                  * ddzu(k+1)                 &
+                                              + s_flux_b(j,i)                 &
+                                            ) * ddzw(k)
+                ENDIF
+
+!
+!--             Vertical diffusion at the last computational gridpoint along
+!--             z-direction
+                IF ( use_top_fluxes  .AND.  k == nzt )  THEN
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                                          + ( - s_flux_t(j,i)                  &
+                                              - 0.5 * ( kh(k-1,j,i)+kh(k,j,i) )&
+                                                    * ( s(k,j,i)-s(k-1,j,i) )  &
+                                                    * ddzu(k)                  &
+                                            ) * ddzw(k)
+                ENDIF
+             ENDDO
+
+          ENDDO
+       ENDDO
+       !$acc end kernels
+
+    END SUBROUTINE diffusion_s_acc
+
+
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_s_ij( i, j, s, s_flux_b, s_flux_t, wall_s_flux )
+
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  vertical_gridspace
+       REAL    ::  wall_s_flux(0:4)
+       REAL, DIMENSION(nysg:nyng,nxlg:nxrg) ::  s_flux_b, s_flux_t
+#if defined( __nopointer )
+       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  s
+#else
+       REAL, DIMENSION(:,:,:), POINTER ::  s
+#endif
+
 !
 !--    Compute horizontal diffusion
Index: /palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_u.f90	(revision 1014)
+++ /palm/trunk/SOURCE/diffusion_u.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -58,5 +58,5 @@
 
     PRIVATE
-    PUBLIC diffusion_u
+    PUBLIC diffusion_u, diffusion_u_acc
 
     INTERFACE diffusion_u
@@ -64,4 +64,8 @@
        MODULE PROCEDURE diffusion_u_ij
     END INTERFACE diffusion_u
+
+    INTERFACE diffusion_u_acc
+       MODULE PROCEDURE diffusion_u_acc
+    END INTERFACE diffusion_u_acc
 
  CONTAINS
@@ -220,4 +224,188 @@
 
 !------------------------------------------------------------------------------!
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_u_acc
+
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  kmym, kmyp, kmzm, kmzp
+
+       !$acc declare create ( usvs )
+       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs
+
+!
+!--    First calculate horizontal momentum flux u'v' at vertical walls,
+!--    if neccessary
+       IF ( topography /= 'flat' )  THEN
+          CALL wall_fluxes_acc( usvs, 1.0, 0.0, 0.0, 0.0, nzb_u_inner, &
+                                nzb_u_outer, wall_u )
+       ENDIF
+
+       !$acc kernels present ( u, v, w, km, tend, usws, uswst )   &
+       !$acc         present ( ddzu, ddzw, fym, fyp, wall_u )           &
+       !$acc         present ( nzb_u_inner, nzb_u_outer, nzb_diff_u )
+       !$acc loop
+       DO  i = nxlu, nxr
+          DO  j = nys, nyn
+!
+!--          Compute horizontal diffusion
+             !$acc loop vector(32)
+             DO  k = 1, nzt
+                IF ( k > nzb_u_outer(j,i) )  THEN
+!
+!--                Interpolate eddy diffusivities on staggered gridpoints
+                   kmyp = 0.25 * &
+                          ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
+                   kmym = 0.25 * &
+                          ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                         & + 2.0 * (                                           &
+                         &           km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   ) &
+                         &         - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) ) &
+                         &         ) * ddx2                                    &
+                         & + ( kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy      &
+                         &   + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx      &
+                         &   - kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy          &
+                         &   - kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx          &
+                         &   ) * ddy
+                ENDIF
+             ENDDO
+
+!
+!--          Wall functions at the north and south walls, respectively
+             !$acc loop vector(32)
+             DO  k = 1, nzt
+                IF( k > nzb_u_inner(j,i)  .AND.  k <= nzb_u_outer(j,i)  .AND. &
+                    wall_u(j,i) /= 0.0 )  THEN
+
+                   kmyp = 0.25 * &
+                          ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
+                   kmym = 0.25 * &
+                          ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                                 + 2.0 * (                                     &
+                                       km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i) ) &
+                                     - km(k,j,i-1) * ( u(k,j,i) - u(k,j,i-1) ) &
+                                         ) * ddx2                              &
+                                 + (   fyp(j,i) * (                            &
+                                  kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy   &
+                                + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx   &
+                                                  )                            &
+                                     - fym(j,i) * (                            &
+                                  kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy       &
+                                + kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx       &
+                                                  )                            &
+                                     + wall_u(j,i) * usvs(k,j,i)               &
+                                   ) * ddy
+                ENDIF
+             ENDDO
+
+!
+!--          Compute vertical diffusion. In case of simulating a Prandtl layer,
+!--          index k starts at nzb_u_inner+2.
+             !$acc loop vector(32)
+             DO  k = 1, nzt_diff
+                IF ( k >= nzb_diff_u(j,i) )  THEN
+!
+!--                Interpolate eddy diffusivities on staggered gridpoints
+                   kmzp = 0.25 * &
+                          ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
+                   kmzm = 0.25 * &
+                          ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                         & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)&
+                         &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx      &
+                         &            )                                        &
+                         &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)&
+                         &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx    &
+                         &            )                                        &
+                         &   ) * ddzw(k)
+                ENDIF
+             ENDDO
+
+          ENDDO
+       ENDDO
+
+!
+!--    Vertical diffusion at the first grid point above the surface,
+!--    if the momentum flux at the bottom is given by the Prandtl law or
+!--    if it is prescribed by the user.
+!--    Difference quotient of the momentum flux is not formed over half
+!--    of the grid spacing (2.0*ddzw(k)) any more, since the comparison
+!--    with other (LES) modell showed that the values of the momentum
+!--    flux becomes too large in this case.
+!--    The term containing w(k-1,..) (see above equation) is removed here
+!--    because the vertical velocity is assumed to be zero at the surface.
+       IF ( use_surface_fluxes )  THEN
+
+          !$acc loop
+          DO  i = nxlu, nxr
+             !$acc loop vector(32)
+             DO  j = nys, nyn
+          
+                k = nzb_u_inner(j,i)+1
+!
+!--             Interpolate eddy diffusivities on staggered gridpoints
+                kmzp = 0.25 * &
+                      ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
+                kmzm = 0.25 * &
+                      ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & + ( kmzp * ( w(k,j,i)   - w(k,j,i-1)   ) * ddx       &
+                      &   ) * ddzw(k)                                        &
+                      & + ( kmzp * ( u(k+1,j,i) - u(k,j,i)     ) * ddzu(k+1) &
+                      &   + usws(j,i)                                        &
+                      &   ) * ddzw(k)
+             ENDDO
+          ENDDO
+
+       ENDIF
+
+!
+!--    Vertical diffusion at the first gridpoint below the top boundary,
+!--    if the momentum flux at the top is prescribed by the user
+       IF ( use_top_fluxes  .AND.  constant_top_momentumflux )  THEN
+
+          k = nzt
+
+          !$acc loop
+          DO  i = nxlu, nxr
+             !$acc loop vector(32)
+             DO  j = nys, nyn
+
+!
+!--             Interpolate eddy diffusivities on staggered gridpoints
+                kmzp = 0.25 * &
+                       ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
+                kmzm = 0.25 * &
+                       ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & - ( kmzm * ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
+                      &   ) * ddzw(k)                                        &
+                      & + ( -uswst(j,i)                                      &
+                      &   - kmzm * ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
+                      &   ) * ddzw(k)
+             ENDDO
+          ENDDO
+
+       ENDIF
+       !$acc end kernels
+
+    END SUBROUTINE diffusion_u_acc
+
+
+!------------------------------------------------------------------------------!
 ! Call for grid point i,j
 !------------------------------------------------------------------------------!
